package com.example.springdemo.controller;

import com.example.springdemo.entities.Merchants;
import com.example.springdemo.entities.password.MerchantsPassword;
import com.example.springdemo.service.MerchantsService;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;

import java.util.Optional;

@RestController
@RequestMapping("/merchants")
public class MerchantsController {
    @Resource
    private MerchantsService merchantsService;

    @PostMapping("/add")
    public Merchants addMerchants(@RequestBody Merchants merchant,
                                  @RequestBody MerchantsPassword merchantPassword) {
        return merchantsService.addMerchant(merchant, merchantPassword);
    }

    @DeleteMapping("/delete/{id}")
    public void deleteMerchants(@PathVariable("id") Long merchantId) {
        merchantsService.deleteMerchantById(merchantId);
    }

    @PutMapping("/update/info")
    public Merchants updateMerchants(@RequestBody Merchants merchant) {
        return merchantsService.updateMerchant(merchant);
    }

    @GetMapping("/find")
    public Iterable<Merchants> getMerchants() {
        return merchantsService.findAllMerchants();
    }

    @GetMapping("/find/{name}")
    public Optional<Merchants> getMerchantsByName(@PathVariable("name") String name) {
        return merchantsService.findByName(name);
    }

    @GetMapping("/find/{id}")
    public Optional<Merchants> getMerchantsById(@PathVariable("id") Long merchantId) {
        return merchantsService.findById(merchantId);
    }

    @PutMapping("/update/password")
    public int updatePassword(@RequestParam String password, @RequestParam Long merchantId) {
        return merchantsService.updateMerchantPasswordById(password, merchantId);
    }
}
