package com.example.springdemo.controller;

import com.example.springdemo.entities.RBAC.Roles;
import com.example.springdemo.service.RolesService;
import com.example.springdemo.utils.RoleVerificationAnnotation;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Optional;

@RoleVerificationAnnotation(UserIDList = {1})
@RestController
@RequestMapping("/roles")
public class RolesController {
    @Resource
    private RolesService rolesService;

    @PostMapping("/add")
    public Roles addRole(@RequestBody Roles role) {
        return rolesService.createRole(role);
    }

    @DeleteMapping("/delete/{id}")
    public void deleteRole(@PathVariable("id") Long roleId) {
        rolesService.deleteRoleById(roleId);
    }

    @PutMapping("/update")
    public Roles updateRole(@RequestBody Roles role) {
        return rolesService.updateRole(role);
    }

    @GetMapping("/find")
    public List<Roles> getAllRoles() {
        return rolesService.findAllRoles();
    }

    @GetMapping("/find/{roleId}")
    public Optional<Roles> getRolesById(@PathVariable Long roleId) {
        return rolesService.findById(roleId);
    }

    @GetMapping("/find/{roleName}")
    public Optional<Roles> getRolesByName(@PathVariable String roleName) {
        return rolesService.findByName(roleName);
    }
}
